var ShoppingItem = Backbone.Model.extend({
	
	defaults: function() {
	      return {
	        title: "Empty item...",
	        /* In order to make Backbone.localStorage work
	         * I have to refer to an actual collection instance here.... */
	        order: shoppingList.nextOrder(),
	        done: false
	      };
	},
	
	toggle: function() {
	     this.save({done: !this.get("done")});
	},
	
	initialize: function() {
		if (!this.get("title")) {
	        this.set({"title": this.defaults().title});
	    }
	}
});