var MainRouter = Backbone.Router.extend({
	
	initialize: function () {
		//this.medicationLogin = 0;	/* -1: checked once, not login, 0 haven't check, 1 checked login */
		//this.profileLogin = 0;		/* -1: checked once, not login, 0 haven't check, 1 checked login */
	this.pageFromlocator = null;
	},
	
	routes: {
		""				: "homePage",
		"login-page"	: "login",
		"profile-page"	: "checkLogin",
		"record-page"	: "checkLogin",
		"transfer-page"	: "transferHandler",
		"shopping-page"	: "refreshShoppingScroller",
		"service-page"	: "refreshServiceScroller",
		"refill-page"	: "refreshRefillScroller",
		"clinic-page"	: "clinicPreload",
		"clinic-detail-page"			: "clinicDetailHandler", 
		"locator-page"	: "locatorPreload",
		"detail-page"	: "showDetailPageButton",
		"direction-page": "directionPageRouter",
		"record-page"   :  "refreshRecordPage",
		"flyer-page"	: "flyerHandler",
		"CommunicationPreferences-page"	: "communicationPageHandler",
		"SecurityPreferences-page"		: "securityPageHandler",
		"myprofile-page"				: "profilePageHandler",
		"termOfUse-page"				: "termOfUseHandler",
		"privacypolicy-page"			: "privacyPolicyHandler",
		"feedback-page"					: "feedBackHandler",
		"resetPass-page"				: "resetPassHandler",
		"enrolment-page"				: "enrolmentHandler",
		"enrolment-form-page"			: "enrolmentFormHandler",
		"enrolment-term-page"			: "enrolmentTermHandler",
		"enrolment-complete-page"		: "enrolmentCompleteHandler",
		"enrolment-request-page"		: "enrolmentRequestHandler",
		"enrolment-wait-page"			: "enrolmentWaitHandler",
		"enrolment-confirm-page"		: "enrolmentConfirmHandler",
		"enrolment-verify-page"			: "enrolmentVerifyHandler",
        "enrollment-medication-record-info-page"		: "enrolmentMedicationRecordHandler",
        "settings-page"                 : "settingsHandler",
	},
	
	enrolmentVerifyHandler: function() {
		$("#header-slider-back").addClass("header-hide");
		enrolmentVerifyView.resetRender();
		enrolmentVerifyView.render();
		setTimeout(function(){
			enrolmentVerifyView.scroll.refresh();
		},240);
	},
	
	enrolmentConfirmHandler: function() {
        $("#header-slider-back").addClass("header-hide");
		enrolmentConfirmView.resetRender();
		setTimeout(function(){
			enrolmentConfirmView.scroll.refresh();
		},240);
	},
	
	enrolmentRequestHandler: function() {
        $("#header-slider-back").addClass("header-hide");
		enrolmentRequestView.resetRender();
		setTimeout(function(){
			enrolmentRequestView.scroll.refresh();
	        enrolmentRequestView.infoScroll.refresh();
		},240);
	},
	enrolmentWaitHandler : function(){
		$("#header-slider-back").addClass("header-hide");
		enrolmentWaitView.resetRender();
		setTimeout(function(){
			enrolmentWaitView.infoScroll.refresh();
		},240);
	},
	
	enrolmentCompleteHandler: function() {
		$("#header-slider-back").addClass("header-hide");
		
		setTimeout(function(){
		    enrolmentCompleteView.scroll.refresh();
            enrolmentCompleteView.infoScroll.refresh();
		},240);
	},
	
    enrolmentMedicationRecordHandler:function() {
        $("#header-slider-back").addClass("header-hide");
    	setTimeout(function(){
    		enrolmentMedicationInfoView.scroll.refresh();
            enrolmentMedicationInfoView.infoScroll.refresh();
		},240);
	},

	enrolmentTermHandler: function() {
    $("#header-slider-back").addClass("header-hide");
	    setTimeout(function(){
	    	enrolmentTermView.scroll.refresh();
		},240);
		/* remember the path */	
		this.previousPage = location.hash;
	},
	
	enrolmentFormHandler: function() {
        $("#header-slider-back").removeClass("header-hide");
		enrolmentFormView.resetRender();
		  setTimeout(function(){
			  enrolmentFormView.scroll.refresh();
			},240);
	},
	
	enrolmentHandler: function() {
		 /* $("#header-slider-back").addClass("header-hide"); */
		 $("#header-slider-back").removeClass("header-hide");		 
		 setTimeout(function(){
			 enrolmentView.scroll.refresh();
			},240);
	},
	
	flyerHandler: function() {
        console.log("entering flyer page");
        setTimeout(function(){
			 if($("#E-Flyer-div").attr("class").indexOf("content-page-flyer-from-store")!=-1){
	            	/* Show menu bar, */
	        	$("#lower-header").removeClass("lower-header-close").addClass("lower-header-open");
	         }else{
	        	$("#lower-header").removeClass("lower-header-open").addClass("lower-header-close");
	         }
			
		},240);

//        $("#lower-header").removeClass("lower-header-close").removeClass("lower-header-open");
//        /* Show menu bar, under the situation of back from refill page */
//		$("#lower-header").addClass("lower-header-open");
//		
//		/* Show locator-detail button group */
//		$("#locator-menu ul li[class='locator-detail']").show(200);
		//$("#locator-menu ul li[class='locator-first']").css("visibility","hidden");
		/* Check if has refill button */
	},
	
	resetPassHandler: function() {
		//resetPasswordView.scroll.refresh();
	},
	
	feedBackHandler: function()	{
		//contactUsView.scroll.refresh();
		$("#header-slider-back").removeClass("header-hide");
        $("#lower-header").removeClass("lower-header-open").addClass("lower-header-close");	
        contactUsView.cleanUp();
		contactUsView.render();
	},
	
	termOfUseHandler: function() {
		//$("#header-slider-back").removeClass("header-hide");
		setTimeout(function(){
			termOfUseView.scroller.refresh();
		},240);

	},
	
	privacyPolicyHandler: function() {	
		$("#header-slider-back").removeClass("header-hide");
		setTimeout(function(){
			privacyPolicyView.scroller.refresh();
		},240);

	},
	
	communicationPageHandler: function() {
		if(!window.localStorage.getItem("JanRainLogin")){
			window.location.replace(window.location.pathname + "#login-page");		
		}else{
			communicationView.render();
			communicationView.scroll.refresh();
		}
	},
	
	securityPageHandler: function() {
		if(!window.localStorage.getItem("JanRainLogin")){
			window.location.replace(window.location.pathname + "#login-page");		
		}else{
			securityView.render();
			securityView.scroll.refresh();
		}
	},
	
	profilePageHandler: function() {
		if(!window.localStorage.getItem("JanRainLogin")){
			window.location.replace(window.location.pathname + "#login-page");		
		}else{
			profileView.render(); 
			profileView.scroll.refresh();
		}
	},
	
	directionPageRouter: function() {
		
//		/* Show menu bar, under the situation of back from refill page */
//		$("#lower-header").removeClass("lower-header-close").addClass("lower-header-open");
//		
//		/* Show direction */
//		/* reset direction page */
//		directionPage.model = storeDetailPage.model;
//		directionPage.render();
//		/* Search by default, from search location */
//		var lt = storeDetailList.lat;
//		var lg = storeDetailList.lng;
//		directionPage.displayDirection(lt, lg);
	
		this.pageFromlocator = null;
		if(!this.previousPage){
			this.pageFromlocator = "#locator-page";
		}
		/* remember the path */	
		this.previousPage = location.hash;
	},
	
	showDetailPageButton: function() {
		/* Show menu bar, under the situation of back from refill page */
		$("#lower-header").removeClass("lower-header-close").addClass("lower-header-open");
		
		/* Show map view button */
		$("#map-view").removeClass("locator-menu-hide");	
		/* Hide detail view button */
		$("#detail-view").addClass("locator-menu-hide");
		/* Hide list view button */
		$("#list-view").addClass("locator-menu-hide");
		/* Show locator-detail button group */
		$("#locator-menu ul li[class='locator-detail']").show(200);
		$("#locator-menu ul li[class='locator-first']").css("visibility","hidden");
		/* Check if has refill button */
		if(storeDetailPage.model.hasRefill()){
			$("#online-refill").show(200);
		}
		setTimeout(function(){
			storeDetailPage.detailScroller.refresh();	
		},240);
		/* remember the path */
		this.previousPage = location.hash;
		appView.resetLocatorMenuColor();
	},
	
	clinicDetailHandler: function() {
		
		/* Show locator-detail button group */
		
		/*clear #clinic-lower-header class*/
		$("#clinic-lower-header").removeClass("lower-header-close").removeClass("lower-header-open");
		/*add #clinic-lower-header open class*/
		$("#clinic-lower-header").addClass("lower-header-open");
		//show map icon
		$("#clinic-list-view").addClass("locator-menu-hide");

        $("#clinic-map-view").removeClass("locator-menu-hide");
        $("#clinic-detail-view").addClass("locator-menu-hide");

		$("#clinic-show-direction").removeClass("locator-menu-hide");
		$("#my-clinic").addClass("locator-menu-hide");
		this.previousPage = location.hash;
	},
	
	homePage: function() {
		/* Back button hide */
		$("#header-slider-back").removeClass("in").addClass("header-hide");
       // $("#header-slider-back").hide();
//		$("#header-slider-back").removeClass("in").addClass("out reverse");
		/* Show logo */
		$("#logo").removeClass("out");//.addClass("in");
		this.previousPage = null;

		/* Clean store locator search field */
		$("#locator-search-input").val("");
		/* Clean store detail data */
		storeDetailPage.model = null;
		/* Hide clinic menu */
		$("#clinic-lower-header").removeClass("lower-header-open").addClass("lower-header-close");

        console.log("homePage clear filter:")
        //hide store locator filter
        storeFilterView.filterReset();
        storeFilterView.filterHide();
        //reset store locator search
        localStorage.setItem("currentq","");
        storeDetailList.lastRefresh = "";
        $("#locator-page").removeClass("locator-page-map-view").addClass("locator-page-list-view");
    	$("#direction-search-input").val("");
        $("#locator-search").css("visibility","hidden");

        //hide clinic locator filter
        clinicFilterView.filterReset();
        clinicFilterView.filterHide();
       
        $("#clinic-page").removeClass("clinic-page-map-view").addClass("clinic-page-list-view");
		$("#clinic-map-view").removeClass("locator-menu-hide");
		$("#clinic-list-view").addClass("locator-menu-hide");	
		$("#clinic-search-input").val("");

        contactUsView.cleanUp();

         //hide shopping list
        shoppingListView.toggleManageListHide();
        //reset flyer page
        var iframe = document.getElementById('flyer-container');
        iframe.src = iframe.src;
        appView.closeClosestStore();
        appView.closeClosestClinicStore();
       // $(".rexall-content .content-page .menu-section .menu-section-content ul li").css({"background-color": "#fdfdfd"});
	},
	
	locatorPreload: function() {
		
		/* Hide Direction button */
//		$("#online-refill").hide();
//		$("#show-direction").hide();
//		$("#show-direction-text").hide();
		/* Open menu */
		$("#lower-header").removeClass("lower-header-close").addClass("lower-header-open");		
//		/* check last refresh time */
//		if(storeDetailList.lastRefresh){
//			var now = new Date();
//			/* Only fetch data 5 mins after the previous fetch */
//			if((now - storeDetailList.lastRefresh) > 500000){ 
//				/* Show spinner */
//				$("#locator-geo-search-load").css("visibility", "visible");
//				$("#locator-search-input").attr("readOnly",true);
//				//locator-page
//				/* Prefetch Data */
//				storeDetailList.fetchDataWithGeo();
//				
//			}
//		}else{
//			/* Show spinner */
//			$("#locator-geo-search-load").css("visibility", "visible");
//			$("#locator-search-input").attr("readOnly",true);
//			/* Prefetch Data */
//			storeDetailList.fetchDataWithGeo();
//			
//		}		/* Show map */


		if($("#detail-view").attr("class")!="locator-menu-hide"&&
			$("#locator-page").attr("class").indexOf("locator-page-map-view") != -1){
				
				$("#locator-menu ul li[class='locator-detail']").show();
				$("#locator-menu ul li[class='locator-first']").css("visibility","hidden");
				/* Check if has refill button */
				if(storeDetailPage.model&&storeDetailPage.model.hasRefill()){
					$("#online-refill").show();
			}
				$("#list-view").addClass("locator-menu-hide");
				$("#map-view").addClass("locator-menu-hide");
				$("#detail-view").removeClass("locator-menu-hide");
		}else if($("#locator-page").attr("class").indexOf("locator-page-map-view") != -1){
				/* store locator Refresh */
				//if(!this.previousPage || this.previousPage != "#detail-page"){
				if(!this.previousPage){

					storeLocatorView.locatorRefresh();
				}
					
				$("#locator-menu ul li[class='locator-detail']").hide();
				$("#locator-menu ul li[class='locator-first']").css("visibility","visible");
				$("#detail-view").addClass("locator-menu-hide");
				$("#map-view").addClass("locator-menu-hide");
				$("#list-view").removeClass("locator-menu-hide");
				//storeListMapView.showMap();
				/* Work around for issue 1066 , better to be done with jQuery pageshow event*/ 
				setTimeout(function(){

					storeListMapView.showMap();
				},800);
		}else{
				/* store locator Refresh */
				//if(!this.previousPage || this.previousPage != "#detail-page"){
				if(!this.previousPage){

					storeLocatorView.locatorRefresh();
				}
					
				$("#locator-menu ul li[class='locator-detail']").hide();
				$("#locator-menu ul li[class='locator-first']").css("visibility","visible");
				$("#detail-view").addClass("locator-menu-hide");
				$("#list-view").addClass("locator-menu-hide");
				$("#map-view").removeClass("locator-menu-hide");
		}
		
		/* Clear out the path memory */
		this.previousPage = null;
		appView.resetLocatorMenuColor();
		

		
	},
	
	clinicPreload: function() {
		/* Open menu */
		$("#clinic-lower-header").removeClass("lower-header-close").addClass("lower-header-open");	
		/* Show locator button group */
		$("#clinic-show-direction").addClass("locator-menu-hide");
//        $("#clinic-detail-view").addClass("locator-menu-hide");
        $("#my-clinic").removeClass("locator-menu-hide");

        console.log("clinicPreload location.hash " + location.hash);
		/* Prefetch Data */
        if(!this.previousPage){
            clinicListView.cleanUp();
            $("#clinic-search-input").val("");
		    clinicDetailList.fetchDataWithGeo(clinicDetailList.phoneGapClinicSuccess);
        }
        if($("#clinic-page").hasClass("clinic-page-map-view")){ // show map view
            if(this.previousPage == "#clinic-detail-page"){  // show detail clinic map view
                $("#my-clinic").addClass("locator-menu-hide");
                $("#clinic-map-view").addClass("locator-menu-hide");
                $("#clinic-show-direction").removeClass("locator-menu-hide");
                $("#clinic-detail-view").removeClass("locator-menu-hide");
            }else{
                setTimeout(function(){
                    clinicListMapView.showMap();
                },500);
            }
        }else if($("#clinic-detail-view").attr("class").indexOf("locator-menu-hide")==-1){
            $("#clinic-detail-view").addClass("locator-menu-hide");
        }
//        if($("#clinic-page").attr("class").indexOf("clinic-page-map-view") != -1){
//        	/*$("#clinic-map-view").addClass("locator-menu-hide");
//        	$("#clinic-list-view").removeClass("locator-menu-hide");*/
//        	setTimeout(function(){
//        		clinicListMapView.showMap();
//    		},500);
//        }
        this.previousPage = null;
    	appView.resetLocatorMenuColor();
	},
	
	refreshRefillScroller: function () {
		
//		if(storeDetailList.lastRefresh){
//			var now = new Date();
//			/* Only fetch data 5 mins after the previous fetch */
//			if((now - storeDetailList.lastRefresh) > 500000){ 
//				/* Prefetch Data */
//				storeDetailList.fetchDataWithGeo();
//			}
//		}else{
//			/* Prefetch Data */
//			storeDetailList.fetchDataWithGeo();
//		}
//		storeDetailList.fetchDataWithGeo();
		
//		/* Render page */ Move the render function to each calling function, enable the refillView keep the data if back for "back" button.
//		refillView.render();
		refillView.refillScroll.scrollTo(0,0,0);
//		refillView.infoScroll.refresh();	/* why need this one? */

		//refillView.refillScroll.refresh(); 	/* should be done in render() */
        
		
		/* Close store locator menu bar */
		//appView.closeClosestStore();
		//refillView.cancel();				Done in render now
		
		
	},
	
	refreshServiceScroller: function() {
		serviceView.pharmacyServiceScroller.refresh();
	},
	
	refreshShoppingScroller: function() {
		shoppingListView.shoppingListScroller.scrollTo(0,0,0);
		shoppingListView.reRenderListItem();
		shoppingListView.shoppingListScroller.refresh();
	},
	
	transferHandler: function() {
		
		/* Refresh the scroller */
//		transferView.transferScroll.refresh();
//		transferView.transferScroll2.refresh();
//		transferView.transferScroll3.refresh();
//		transferView.transferScroll4.refresh();
/* Move to AppView go to Page function 
		transferView.render();
*/
		transferView.transferScroll2.scrollTo(0,0,0);
		transferView.cleanUp();
        setTimeout(function(){
            transferView.transferScroll.refresh();
            transferView.transferScroll2.refresh();
            transferView.transferScroll3.refresh();
            transferView.transferScroll4.refresh();
        },240);  
        this.previousPage = location.hash;
	},
	
	login: function () {
		
		/* Close store locator menu bar */
		appView.closeClosestStore();
		/* Back button show */
		$("#header-slider-back").removeClass("header-hide").addClass("slidefade in");
		/* Page header show */
		//var headerId = "#login-header";
		//$(headerId).removeClass("header-hide").addClass("slidefade in");
		/* Hide clinic menu */
		$("#clinic-lower-header").removeClass("lower-header-open").addClass("lower-header-close");
		if(window.localStorage.getItem("JanRainLogin")){
			window.history.go(-1);
		}
	
	},
	
	checkLogin: function(){
		if(!window.localStorage.getItem("JanRainLogin")){
			//jAlert("Please login first","Rexall");
			window.location.replace("#login-page");		
		}
	  
	},
	refreshRecordPage : function(){
		
		/* Change header */
		var currentStore = localStorage.getItem("CurrentStore");
		var homeStore = localStorage.getItem("RexallProfileHomeStore");
		if(homeStore)
	    {
			$("#record-manual-refill-header-mystore").html(JSON.parse(homeStore).Address);
	    }
        else if (janrainLogin.get("hasLogin"))
        {
            $("#record-manual-refill-header-mystore").html("");
        }
        else if(currentStore){
	        $("#record-manual-refill-header-mystore").html(JSON.parse(currentStore).Address);
	       
	    }
		
        console.log("mainRouter refreshRecordPage header-mystore:" + $("#record-manual-refill-header-mystore").html());
		/* Check Login */
		if(!window.localStorage.getItem("JanRainLogin")){
              //          loginView.setFromRefill(true);
			//jAlert("Please login first","Rexall");
			window.location.replace("#login-page");		
		}else{
			$("#login-header").removeClass("slidefade in").addClass("header-hide");
			//recordListView.scroller.refresh();
		}
	},
	settingsHandler : function(){
		
		this.previousPage = location.hash;
		
	},
	
});