﻿var EnrolmentMedicationInfoView = Backbone.View.extend({
	
	el: $("#enrollment-medication-record-info-page"),

	events: {
		"tap #medication-record-info-continue"	: "request",
		"tap .rexall-page-header-info"		: "showInfo",
		"tap .rexall-page-info-popup-close"	: "closeInfo",
	},
	
	initialize: function() {
		
		/* Setup page scroller */
		this.scroll = new iScroll("enrollment-medication-record-info-scroll",{
			hScroll:false, 
			vScroll:true, 
			vScrollbar: true, 
			hScrollbar: false, 
			fadeScrollbar: true, 
			hideScrollbar:true,
			});

        /* Set up popup information scroller */
		this.infoScroll = new iScroll("enrollment-medication-record-info-page-info-scroll",{
			hScroll:false, 
			vScroll:true, 
			vScrollbar: true, 
			hScrollbar: false, 
			fadeScrollbar: true, 
			hideScrollbar:true,
			});
		
	},
	
	/* Request activation code */
	request: function() {
		
//		/* Reset form */
//		if(enrolmentRequestView)
//			enrolmentRequestView.resetRender();
		$("#header-slider-back").removeClass("header-hide");
		
		/* Go to request page */
		var id = "#enrolment-request-page";
		$.mobile.changePage(id, {transition: 'slide'});
	},
	
	
	
	/* Show refill page information pop up */
	showInfo: function(e) {

		e.preventDefault();

		/* Open information box */
		$("#enrollment-medication-record-info-page-info").popup( "option", "history", false );
		$("#enrollment-medication-record-info-page-info").popup({ transition: "pop" });
		$("#enrollment-medication-record-info-page-info").popup("open");

	},

	/* Close information */
	closeInfo: function(e) {

		e.preventDefault();

		$("#enrollment-medication-record-info-page-info").popup("close");

	},
	
});