var PharmacyServiceView = Backbone.View.extend({
	
	el: $("#service-page"),
	
	initialize: function() {
		this.services = new Array();
		
		/* Scroll */
		this.pharmacyServiceScroller = new iScroll('service-scroll-wrapper',
		    {
                snap:'li',
                hScroll:false,
                vScroll:true,
                vScrollbar: true,
                hScrollbar: false,
                fadeScrollbar: true,
                hideScrollbar:true,
                onBeforeScrollStart: function (e) {
    //					var nodeType = e.explicitOriginalTarget ? e.explicitOriginalTarget.nodeName.toLowerCase():(e.target ? e.target.nodeName.toLowerCase():"");
    //					if(nodeType !='select' && nodeType !='option' && nodeType !='input' && nodeType!='textarea')
    //                        e.preventDefault();
                        // commented the above lines out because from Cordova 4.0 upgrade, this will prevent Android's keyboard
                        // from hidding after user unfocus an input field
                    }
            }
        );
	},
	
	moveUp: function(view) {
		/* Close all services */
		$.each(this.services, function(index, value) {
			value.close();
		});
		/* move up the input view */
		var upView = view.$el;
		$(".service-list").prepend(upView);
		view.open();
	}

});