var PharmacyView = Backbone.View.extend({
	
	el: $("#pharmacy-page"),
	
	events: {
		"tap .rexall-page-header-info"		: "showInfo",
		"tap .rexall-page-info-popup-close"	: "closeInfo",
	},
	
	initialize: function() {
		
		/* Set up popup information scroller */
		this.infoScroll = new iScroll("pharmacy-info-scroll",{
			hScroll:false, 
			vScroll:true, 
			vScrollbar: true, 
			hScrollbar: false, 
			fadeScrollbar: true, 
			hideScrollbar:true,
			});

	},

	refresh: function() {
		/* Take focus on any button */
		/*setTimeout(
		function(){
		var str = navigator.userAgent;
		if (str.indexOf("Chrome") == -1)
		{
			$(".fixthis").addClass('rexall-not-kitkat');
		}
		else
		{
			$(".fixthis").addClass('rexall-kitkat');
		}
		},300);*/
	},
	
	/* Pop up information */
	showInfo: function(e) {
		e.preventDefault();
		/* Open information box */
		$("#pharmacy-page-info").popup( "option", "history", false );
		$("#pharmacy-page-info").popup({ transition: "pop" });
		$("#pharmacy-page-info").popup("open");
		this.infoScroll.refresh();
	},
	
	/* Close information */
	closeInfo: function(e) {
		e.preventDefault();
		$("#pharmacy-page-info").popup("close");
	},
	
});