var ServiceStoreView = Backbone.View.extend({
	
	tagName:"li",
	
	template: Handlebars.compile($("#service-list-store").html()),
	
	events: {
		"tap .service-list-store-li"		: "showDetail",
	},
	
	render: function() {
		this.$el.html(this.template(this.model.toJSON()));
		return this;
	},
	
	showDetail:	function () {
		var id = "#detail-page";
		$.mobile.changePage(id, {transition: 'slide'});
		/* Change appView currentPage */
		appView.currentPage = id;
		/* Setup Detail page */
		storeDetailPage.setModel(this.model);
		storeDetailPage.render();
	},
	
});