var StoreLocatorView = Backbone.View.extend({
	
	initialize: function () {
	
		/* Create new collection for this view */
//	    this.collection = new StoreDetailList();
//		this.listenTo(this.collection, "add", this.addOne);		/* Listen to collection of this view */
//		this.listenTo(this.collection, "reset", this.cleanup);	/* Listen to collection of this view */
	     this.fromPage = "";
	},

	
	el: $("#locator-page"),
	
	events: {
		//"tap #locator-search-submit" 		: "searchStores",
		"tap #locator-search-submit-wrapper": "searchStoresSubmit",
		"keypress #locator-search-input"	: "keySearchStores",
		"tap .rexall-page-header-info"		: "showInfo",
		"tap .rexall-page-info-popup-close"	: "closeInfo",
	},

	keySearchStores : function (e) {
		if(e.keyCode === 13) {
			this.searchStores("StoresSearch");
		}
	},
	
    searchStoresSubmit: function(e) {
    e.preventDefault();
        this.searchStores("StoresSearch");
    },

	searchStores : function(fromPage) {
	    this.fromPage = fromPage;
	    localStorage.setItem("currentq","");
		var q = $("#locator-search-input").val();
		/*if(q){
		    localStorage.setItem("currentq",q);
			this.collection.fetchDataWithInput(q);*/
			/* Empty search box */
			/*$("#locator-search-input").val("");
		}else{
			jAlert("Enter a valid address.","Please Try Again");
		}*/
		var self = this;
		if(q){
//			     if(serviceList.length>0)
//				 {   
//					 geocoder = new google.maps.Geocoder();
//					 geocoder.geocode( { 'address': q}, function(results, status) {
//						if (status == google.maps.GeocoderStatus.OK) { 
//							   /* Search this sepecific location */alert("google search");
//							   self.populateStores(results);
//						}else{
//							   alert('Geocode was not successful for the following reason: ' + status);
//							   return false;
//					    }
//					  });
//			     }else{
			
			this.collection.fetchLocatorDataWithInput(q);
			/* Close the search box */
			if(this.appView){
				this.appView.searchHide();
			}
//			    }
		}else{
			jAlert("Provide a valid address.","Please Try Again");
			return false;
		}
	},
	
	locatorRefresh: function(){
		//$("#locator-search-input").blur();
		var q = localStorage.getItem("currentq");
		if(q){
			this.collection.fetchDataWithInput(q);
			/* Empty search box */
			$("#locator-search-input").val("");
		}else{
//			var storeDetailList1 = new StoreDetailList();
//			var storeListView1 = new StoreListView({"collection" : storeDetailList1});	
//			storeDetailList1.fetchDataWithGeo();
			/* Check wether the user has updated location first */
			if(!this.collection.hasUpdatedLocation()){
				storeListView.cleanUp();
				this.collection.fetchDataWithGeo();
			}
			
		}
		
	},
	
	 populateStores: function(results) {alert("populate");
		var lat = results[0].geometry.location.lat();
	    var lng = results[0].geometry.location.lng();
	    
	    /* remove original stores */
	    this.collection.reset();
	    
	    Array.prototype.contains = function(element) {  
    	for (var i = 0; i < this.length; i++) {  
        	if (this[i] == element) {  
            	return true;  
        	}  
    	 }  
    	 return false;  
		} ; 
	    
	    /* fetch data */
	    if(serviceList.contains("Medical Clinic"))
	    {
	    	this.collection.fetchDataWithLocation(lat, lng, 400);
	    }else{
	    	this.collection.fetchDataWithLocation(lat, lng);
	    }
	    //reset my location
	    storeListMapView.myLocation = new google.maps.LatLng(lat,lng);
	    storeListMapView.collection.lat=lat;
	    storeListMapView.collection.lng=lng;
	    storeListMapView.collection.reset();
	    
	},

	/**
	 * It would be better if we do this step in StoreListView.js, for better modularization
	 */
//	addOne: function (item) {
//	    //alert(item.toJSON().StoreServices);
//		/* First need to filter out the stores without the services */
//		if(serviceList.length>0)
//		{
//			if(item.toJSON().StoreServices.indexOf(serviceList[0]) >= 0){
//				//var storeListView = new StoreListView({model : item});
//				var storeListItemView = new StoreListItemView({model : item});
//				this.$el.find("#locator-list-ul").append(storeListItemView.render().el);
//				storeListMapView.collection.models.push(item);
//				//var storeListMapView = new StoreListMapView({model : item});
//			}
//		}else{
//		    var storeListItemView = new StoreListItemView({model : item});
//			this.$el.find("#locator-list-ul").append(storeListItemView.render().el);
//			storeListMapView.collection.models.push(item);
//		}
//		/* Refresh list scroller, should not doing it here!!.. */
//		storeListView.listScroller.refresh();
//		/* Show map */
//		storeListMapView.showMap();
//	},
	
	cleanup: function () {
		/* Remove the history of previews search */
		this.$el.find("#locator-list-ul").html("");
	},
	
	/* Pop up information */
	showInfo: function(e) {
		e.preventDefault();
		/* Open information box */
		$("#locator-page-info").popup( "option", "history", false );
		$("#locator-page-info").popup({ transition: "pop" });
		$("#locator-page-info").popup("open");
	},
	
	/* Close information */
	closeInfo: function(e) {
		e.preventDefault();
		$("#locator-page-info").popup("close");
	},
	
	/* Set appView object */
	setApp: function(app){
		this.appView = app;
	}
	
});