﻿var ContactUs = Backbone.Model.extend({

	initialize: function () {
	},

    requestContactUs: function(backOrNot) {
            $("#contact-us-spinner").css("visibility", "visible");
            var janRainLogin = localStorage.getItem("JanRainLogin");
            var data;   
            var channel = "MOB"; 
            
			/* check if user has profile in local storage	*/
            if(janRainLogin&&profile.hasProfile&&profile.hasRecord()) {     
                 var profilemodel = localStorage.getItem("RexallProfile");
                //console.log(JSON.stringify(janRainLogin));
                //console.log(JSON.stringify(profilemodel));

			     data = {
				    APIKey: getSecureWebserviceAPIKey(),
                    FirstName: JSON.parse(profilemodel).profile.firstName, //JSON.parse(janRainLogin).givenName,
                    LastName: JSON.parse(profilemodel).profile.lastName, //JSON.parse(janRainLogin).familyName,
                    Email: JSON.parse(janRainLogin).email,
	                Phone: JSON.parse(profilemodel).profile.homePhone,
                    Topic: $("#feedback-topic-selection").val(),
                    Message: $("#feedback-patient-Message").val(),
                    Address: JSON.parse(profilemodel).profile.addressLine1,
                    City: JSON.parse(profilemodel).profile.city,
                    Province: JSON.parse(profilemodel).profile.province,
                    PostalCode: JSON.parse(profilemodel).profile.postalCode,
                    Channel: channel, 
	                };
            }
            else
            {
            	var contact_us_number = $("#contact-us-number").val();
                data = {
				    APIKey: getSecureWebserviceAPIKey(),
                    FirstName:  $("#contact-us-fname").val(), //JSON.parse(janRainLogin).givenName,
                    LastName: $("#contact-us-lname").val(), //JSON.parse(janRainLogin).familyName,
                    Email: $("#contact-us-email").val(),
                    Phone: contact_us_number.substring(1,4) + "-" + contact_us_number.substring(6,9) + "-" + contact_us_number.substring(10,14),
                    Topic: $("#feedback-topic-selection").val(),
                    Message: $("#feedback-patient-Message").val(),
                    Address: $("#contact-us-address").val(),
                    City: $("#contact-us-city").val(),
                    Province: $("#contact-us-province").val(),
                    PostalCode: $("#contact-us-zip").val(),
                    Channel: channel,
	                };
            }

// alert(JSON.stringify(data));	
        	
		$.ajax({
            url:  getMyRexallWebserviceRoot() + "v3/secure/SecureRexall.svc/ContactRequest/", //"https://www.rexall.ca/profile/processTransfer",
            type: 'get',
            data: data,
            dataType: 'json',
            timeout: 8000,
            async: false,
            success: function(data) {
              //  alert(JSON.stringify(data));
              $("#contact-us-spinner").css("visibility", "hidden");
                if (data.Status == 0)
                {
                    jAlert("Your information has been successfully submitted.", "Contact Us");
                    if(appView && backOrNot)
                    	appView.goBack();			/* Go back */
                    if(contactUsView)
                    	contactUsView.cleanUp();	/* Clean up input fields */
                }
                else
                {
                    jAlert("Cannot process your request, please try again later.", "Something Went Wrong"); 
                }

            },
            error: function(XHR, textStatus, error) {
                $("#contact-us-spinner").css("visibility", "hidden");
                jAlert("Unable to send the message, please check your network connection.", "Something Went Wrong");
	    	}
        });

	},
});