var ShoppingList = Backbone.Collection.extend({
 
    model: ShoppingItem,
 
    localStorage: new Backbone.LocalStorage("rexall-shopping"),

    initialize: function() {
    	//alert(JSON.stringify(localStorage.getItem("Rexall")));
    },
    
    done: function() {
      return this.where({done: true});
    },
    
    notDone: function() {
        return this.where({done: false});
    },
    
    everyOne: function() {
    	return this.where();
    },
    
//    remaining: function() {
//      return this.without.apply(this, this.done());
//    },
    
    nextOrder: function() {
      if (!this.length) return 1;
      return this.last().get('order') + 1;
    },
 
    comparator: 'order',

  });