/*
 * Prescription transfer object
 */
var Transfer = Backbone.Model.extend({
	
	initialize: function(TransferToStore) {
		if(TransferToStore) 
			this.TransferToStore = TransferToStore;
	},
	
	requestTransfer: function() {
		//alert("Under construction...");
		    //alert(JSON.stringify(localStorage.getItem("RexallProfile")));
            var janRainLogin = localStorage.getItem("JanRainLogin");

             var frompharmacy;
             if($("#transfer-form-existing-pharmacy").val() == "ChooseFromList" )
             {
                frompharmacy = $("#transfer-pharmacy-other").val();
             }
             else{
                frompharmacy =$("#transfer-form-existing-pharmacy").val();
             }
             var ExistingPharmacyPhoneInput = $("#transfer-pharmacy-phone").val();
			 
             var ExistingPharmacyPhone = ExistingPharmacyPhoneInput.substring(1,4) + "-" +
			     ExistingPharmacyPhoneInput.substring(6,9) + "-" +
				 ExistingPharmacyPhoneInput.substring(10,14) ;

             var profilemodel = localStorage.getItem("RexallProfile");

			var data;
			
			var transferMobilePhone;

			var hasProfileRecord = janRainLogin && profile.hasProfile && profile.hasRecord(); 
			
			/*	Use home store or preferred store as the accepting pharmacy by default */
			var	store;
			if (localStorage.getItem("RexallProfileHomeStore")) {	/* Use profile store (must have login) */
				store = JSON.parse(localStorage.getItem("RexallProfileHomeStore"));
			} else {
				if (localStorage.getItem("CurrentStore")) { 
					store = JSON.parse(localStorage.getItem("CurrentStore"));
				}
			}
			
			/* Format JanRain data */
			if (hasProfileRecord)
				{
					var JanRainBirthDate = JSON.parse(profilemodel).profile.birthDate;
					var transferBirthDate = JanRainBirthDate.substring(6,8) + "-" + 
											JanRainBirthDate.substring(4,6) + "-" + 
											JanRainBirthDate.substring(0,4) ;

			      	var JanRainHomePhone = JSON.parse(profilemodel).profile.homePhone;			 
					var transferJanRainHomePhone = JanRainHomePhone.substring(0,3) + "-" +
						JanRainHomePhone.substring(3,6) + "-" +
						JanRainHomePhone.substring(6,10) ;															
				   };
				   			
			if (!hasProfileRecord)
			      {
			      	/* Get patient details from user input */
			      	var HomePhoneInput = $("#transfer-home-phone").val();			 
					var transferHomePhone = HomePhoneInput.substring(1,4) + "-" +
						HomePhoneInput.substring(6,9) + "-" +
						HomePhoneInput.substring(10,14) ;		
						
					var MobilePhoneInput = $("#transfer-mobile-phone").val();			 

					var transferMobilePhone = "";
					if($("#transfer-mobile-phone").inputmask('unmaskedvalue').length<=0){
						transferMobilePhone = "";
					}else{
						transferMobilePhone = MobilePhoneInput.substring(1,4) + "-" +
						MobilePhoneInput.substring(6,9) + "-" +
						MobilePhoneInput.substring(10,14) ;	
					}
				   };	

			var notes1, notes2, notes3; 
			if ($("#fill-other1").val()) { 
				notes1 = $("#fill-notes1").val() + ". Other Notes: " + $("#fill-other1").val(); 
			}else{
		        notes1 = $("#fill-notes1").val();
		    } 
		    
		    if ($("#fill-other2").val()) { 
				notes2 = $("#fill-notes2").val() + ". Other Notes: " + $("#fill-other2").val(); 
			}else{
		        notes2 = $("#fill-notes2").val();  
		    } 
		    
		    if ($("#fill-other3").val()) { 
		    	notes3 = $("#fill-notes3").val() + ". Other Notes: " + $("#fill-other3").val(); 
		    }else{
		        notes3 = $("#fill-notes3").val();	
		    } 	
		                				   
			if($("#transfer-add-drug3").val().length > 0){
				data = {
						APIKey: getSecureWebserviceAPIKey(),
		                FirstName: (hasProfileRecord) ? JSON.parse(profilemodel).profile.firstName : $("#transfer-patient-first-name").val() , 
		                LastName: (hasProfileRecord) ? JSON.parse(profilemodel).profile.lastName : $("#transfer-patient-last-name").val() , 
		                ExistingPharmacyBanner:  frompharmacy ,
		                ExistingPharmacyPhone:   ExistingPharmacyPhone ,
						
		                /* AcceptingPharmacyNumber: (!($("#transfer-search-location-result").val())) ?
		                          JSON.parse(this.TransferToStore).StoreNumber : $("#transfer-search-location-result").val() , */
						AcceptingPharmacyNumber: (!($("#transfer-search-location-result").val())) ? store.StoreNumber : $("#transfer-search-location-result").val() , 
								  
		                TransferAll: false,

			            Email: (hasProfileRecord) ? JSON.parse(janRainLogin).email : $("#transfer-patient-email").val() ,
			            name: (hasProfileRecord) ? JSON.parse(janRainLogin).displayName : $("#transfer-patient-first-name").val() ,

		                HomePhone: (hasProfileRecord) ? transferJanRainHomePhone : transferHomePhone ,
		                MobilePhone: (hasProfileRecord && JSON.parse(janRainLogin).primaryAddress) ? JSON.parse(janRainLogin).primaryAddress.mobile : transferMobilePhone ,
		                
		                BirthDate: (hasProfileRecord) ? transferBirthDate : $("#transfer-birth-date").val() ,
		                Address: (hasProfileRecord) ? JSON.parse(profilemodel).profile.addressLine1 : $("#transfer-patient-address").val() ,
						City: (hasProfileRecord) ? JSON.parse(profilemodel).profile.city : $("#transfer-patient-city").val() ,
						Province: (hasProfileRecord) ? JSON.parse(profilemodel).profile.province : $("#transfer-form-existing-province").val() ,
		                PostalCode: (hasProfileRecord) ? JSON.parse(profilemodel).profile.postalCode : $("#transfer-patient-postal").val() ,	                
		                
		                Scripts: [
		                		  {
		                		    DrugName: $("#transfer-add-drug1").val() ,
		                		    RxNumber: $("#transfer-add-rx1").val() ,
									Notes: 	notes1,
		                		    FillImmediately: ($('input[name="fill-now1"]:checked').val() == "fill") ? true : false  ,
		                		    Hold: ($('input[name="fill-now1"]:checked').val() == "hold") ? true : false
		                	      },
		                		  {
		                		    DrugName: $("#transfer-add-drug2").val() ,
		                		    RxNumber: $("#transfer-add-rx2").val() ,
		                		    Notes: notes2,
		                		    FillImmediately: ($('input[name="fill-now2"]:checked').val() == "fill") ? true : false  ,
		                		    Hold: ($('input[name="fill-now2"]:checked').val() == "hold") ? true : false
		                	      },
		                		  {
		                		    DrugName: $("#transfer-add-drug3").val() ,
		                		    RxNumber: $("#transfer-add-rx3").val() ,
		                		    Notes: notes3,
		                		    FillImmediately: ($('input[name="fill-now3"]:checked').val() == "fill") ? true : false  ,
		                		    Hold: ($('input[name="fill-now3"]:checked').val() == "hold") ? true : false
		                	      }		                	      			                	                                
		                        ],

                        Method: hasProfileRecord ? "MyRexall" : "Manual"

			        };
			}else{
			if($("#transfer-add-drug2").val().length > 0){
				data = {
						APIKey: getSecureWebserviceAPIKey(),
		                FirstName: (hasProfileRecord) ? JSON.parse(profilemodel).profile.firstName : $("#transfer-patient-first-name").val() , 
		                LastName: (hasProfileRecord) ? JSON.parse(profilemodel).profile.lastName : $("#transfer-patient-last-name").val() , 
		                ExistingPharmacyBanner:  frompharmacy ,
		                ExistingPharmacyPhone:   ExistingPharmacyPhone ,
						
		                /* AcceptingPharmacyNumber: (!($("#transfer-search-location-result").val())) ?
		                          JSON.parse(this.TransferToStore).StoreNumber : $("#transfer-search-location-result").val() , */
		                AcceptingPharmacyNumber: (!($("#transfer-search-location-result").val())) ?store.StoreNumber : $("#transfer-search-location-result").val() , 
						
		                TransferAll: false,

			            Email: (hasProfileRecord) ? JSON.parse(janRainLogin).email : $("#transfer-patient-email").val() ,
			            name: (hasProfileRecord) ? JSON.parse(janRainLogin).displayName : $("#transfer-patient-first-name").val() ,

		                HomePhone: (hasProfileRecord) ? transferJanRainHomePhone : transferHomePhone ,
		                MobilePhone: (hasProfileRecord && JSON.parse(janRainLogin).primaryAddress) ? JSON.parse(janRainLogin).primaryAddress.mobile : transferMobilePhone,
		                
		                BirthDate: (hasProfileRecord) ? transferBirthDate : $("#transfer-birth-date").val() ,
		                Address: (hasProfileRecord) ? JSON.parse(profilemodel).profile.addressLine1 : $("#transfer-patient-address").val() ,
						City: (hasProfileRecord) ? JSON.parse(profilemodel).profile.city : $("#transfer-patient-city").val() ,
						Province: (hasProfileRecord) ? JSON.parse(profilemodel).profile.province : $("#transfer-form-existing-province").val() ,
		                PostalCode: (hasProfileRecord) ? JSON.parse(profilemodel).profile.postalCode : $("#transfer-patient-postal").val() ,

		                Scripts: [ 
		                		  {
		                		    DrugName: $("#transfer-add-drug1").val() ,
		                		    RxNumber: $("#transfer-add-rx1").val() ,
		                		    Notes: notes1,
		                		    FillImmediately: ($('input[name="fill-now1"]:checked').val() == "fill") ? true : false  ,
		                		    Hold: ($('input[name="fill-now1"]:checked').val() == "hold") ? true : false
		                	      },  
		                		  {
		                		    DrugName: $("#transfer-add-drug2").val() ,
		                		    RxNumber: $("#transfer-add-rx2").val() ,
		                		    Notes: notes2,
		                		    FillImmediately: ($('input[name="fill-now2"]:checked').val() == "fill") ? true : false  ,
		                		    Hold: ($('input[name="fill-now2"]:checked').val() == "hold") ? true : false
		                	      }		                	                              
		                        ],

                        Method: hasProfileRecord ? "MyRexall" : "Manual"
			        };
			}else{
			if($("#transfer-add-drug1").val().length > 0){
		
				data = {
						APIKey: getSecureWebserviceAPIKey(),
		                FirstName: (hasProfileRecord) ? JSON.parse(profilemodel).profile.firstName : $("#transfer-patient-first-name").val() , 
		                LastName: (hasProfileRecord) ? JSON.parse(profilemodel).profile.lastName : $("#transfer-patient-last-name").val() , 
		                ExistingPharmacyBanner:  frompharmacy ,
		                ExistingPharmacyPhone:   ExistingPharmacyPhone ,
		                
						/* AcceptingPharmacyNumber: (!($("#transfer-search-location-result").val())) ?
		                          JSON.parse(this.TransferToStore).StoreNumber : $("#transfer-search-location-result").val() , */
		                AcceptingPharmacyNumber: (!($("#transfer-search-location-result").val())) ? store.StoreNumber : $("#transfer-search-location-result").val() , 
						
		                TransferAll: false,

			            Email: (hasProfileRecord) ? JSON.parse(janRainLogin).email : $("#transfer-patient-email").val() ,
			            name: (hasProfileRecord) ?  JSON.parse(janRainLogin).displayName : $("#transfer-patient-first-name").val() ,

		                HomePhone: (hasProfileRecord) ? transferJanRainHomePhone : transferHomePhone ,
		                MobilePhone: (hasProfileRecord && JSON.parse(janRainLogin).primaryAddress) ? JSON.parse(janRainLogin).primaryAddress.mobile : transferMobilePhone ,
		                
		                BirthDate: (hasProfileRecord) ? transferBirthDate : $("#transfer-birth-date").val() ,
		                Address: (hasProfileRecord) ? JSON.parse(profilemodel).profile.addressLine1 : $("#transfer-patient-address").val() ,
						City: (hasProfileRecord) ? JSON.parse(profilemodel).profile.city : $("#transfer-patient-city").val() ,
						Province: (hasProfileRecord) ? JSON.parse(profilemodel).profile.province : $("#transfer-form-existing-province").val() ,
		                PostalCode: (hasProfileRecord) ? JSON.parse(profilemodel).profile.postalCode : $("#transfer-patient-postal").val()  ,

		                Scripts: [        
		                		  {
		                		    DrugName: $("#transfer-add-drug1").val() ,
		                		    RxNumber: $("#transfer-add-rx1").val() ,
		                		    Notes: notes1,
		                		    FillImmediately: ($('input[name="fill-now1"]:checked').val() == "fill") ? true : false  ,
		                		    Hold: ($('input[name="fill-now1"]:checked').val() == "hold") ? true : false
		                	      }	                          
		                        ],
                        Method: hasProfileRecord ? "MyRexall" : "Manual"
			        };
			}else{
			
				data = {
						APIKey: getSecureWebserviceAPIKey(),
		                FirstName: (hasProfileRecord) ? JSON.parse(profilemodel).profile.firstName : $("#transfer-patient-first-name").val() , 
		                LastName: (hasProfileRecord) ? JSON.parse(profilemodel).profile.lastName : $("#transfer-patient-last-name").val() , 
		                ExistingPharmacyBanner:  frompharmacy ,
		                ExistingPharmacyPhone:   ExistingPharmacyPhone ,
		                
						/* AcceptingPharmacyNumber: (!($("#transfer-search-location-result").val())) ?
		                          JSON.parse(this.TransferToStore).StoreNumber : $("#transfer-search-location-result").val() , */
		                AcceptingPharmacyNumber: (!($("#transfer-search-location-result").val())) ?store.StoreNumber : $("#transfer-search-location-result").val() , 
						
		                TransferAll: true,

			            Email: (hasProfileRecord) ? JSON.parse(janRainLogin).email : $("#transfer-patient-email").val() ,
			            name: (hasProfileRecord) ? JSON.parse(janRainLogin).displayName : $("#transfer-patient-first-name").val() , 
		                HomePhone: (hasProfileRecord) ? transferJanRainHomePhone : transferHomePhone ,
		                MobilePhone: (hasProfileRecord && JSON.parse(janRainLogin).primaryAddress) ? JSON.parse(janRainLogin).primaryAddress.mobile : transferMobilePhone ,
		                
		                BirthDate: (hasProfileRecord) ? transferBirthDate : $("#transfer-birth-date").val() ,
		                Address: (hasProfileRecord) ? JSON.parse(profilemodel).profile.addressLine1 : $("#transfer-patient-address").val() ,
						City: (hasProfileRecord) ? JSON.parse(profilemodel).profile.city : $("#transfer-patient-city").val() ,
						Province: (hasProfileRecord) ? JSON.parse(profilemodel).profile.province : $("#transfer-form-existing-province").val() ,
		                PostalCode: (hasProfileRecord) ? JSON.parse(profilemodel).profile.postalCode : $("#transfer-patient-postal").val(),

                        Method: hasProfileRecord ? "MyRexall" : "Manual"
			        };

			}
			}
			}
			
// alert(JSON.stringify(data));

		$.ajax({
            url:  getMyRexallWebserviceRoot() + "v3/secure/SecureRexall.svc/TransferRequest/", //"https://www.rexall.ca/profile/processTransfer",
            type: 'get',
            data: data,
            dataType: 'json',
            timeout: 8000,
            async: false,
            success: function(data) {
                if (data.Status == 0){
                    jAlert("Thank you for requesting a prescription transfer. Your request is being processed. <br/>Our pharmacist will call the pharmacy on your behalf to arrange the transfer of your prescription(s).", "Transfer Prescription");
                    if(appView)
                        appView.goBack();
                }else{
                   jAlert("Can not process your request, please try again later.", "Something Went Wrong"); 
                }
                
            },
            error: function() {
            	jAlert("Can not process your request, please try again later.", "Something Went Wrong"); 
            }
        });
	},
	transferCallBack: function(data, self) {
		alert("call back");
		alert(JSON.stringify(data));
	},
});