var EnrolmentFormView = Backbone.View.extend({
	
	el: $("#enrolment-form-page"),
	
	events: {
		"tap #enrolment-continue"		: "continue",
	},
	
	initialize: function() {
	
				/* for now, clear fields and values before starting */
			    localStorage.setItem("EnrolmentRequestMyRexallID", "");
            	localStorage.setItem("EnrolmentRequestMyRexallUUID", "");
            	localStorage.setItem("EnrolmentRequestMyRexallEMAIL", "");
            	localStorage.setItem("EnrolmentRequestMyRexallSTORE", "");
            	$("#enrolment-request-rx").val("");
            	setHTML5DateFormat("enrolment-request-birthdate");
            	//$("#enrolment-request-birthdate").inputmask("dd/mm/yyyy");	
            	$("#enrolment-request-location-result").val("");
            	$("#enrolment-name").val("");
            	$("#enrolment-email").val("");
            	$("#enrolment-province").val("ChooseFromList");
            	$("#enrolment-password").val("");
            	$("#enrolment-confirm-password").val("");
            	$("#enrolment-security-question").val("ChooseFromList");
            	$("#enrolment-security-answer").val("");
            	$("#enrolment-confirm-code").val("");
            	$("#enrolment-confirm-rx").val("");
            	setHTML5DateFormat("enrolment-confirm-birthdate");
            	$("#enrolment-verify-question1").val("ChooseFromList");
            	$("#enrolment-verify-question2").val("ChooseFromList");
            	
        this.backFromRejectTermandCondition = false;  
         	
		/* Setup page scroller */
		this.scroll = new iScroll("enrolment-form-scroll",{

			hScroll:false, 
			vScroll:true, 
			vScrollbar: true, 
			hScrollbar: false, 
			fadeScrollbar: true, 
			hideScrollbar:true,
			onBeforeScrollStart: function (e) { 
			

            	
				var nodeType = e.explicitOriginalTarget ? e.explicitOriginalTarget.nodeName.toLowerCase():(e.target ? e.target.nodeName.toLowerCase():"");
				if(nodeType !='select' && nodeType !='option' && nodeType !='input' && nodeType!='textarea'){
                    // commented this line out because from Cordova 4.0 upgrade, this will prevent Android's keyboard
                    // from hidding after user unfocus an input field
                    //e.preventDefault();
				}else{	/* Auto scroll up for the input field */				
					var selfScroll = this;					
					/* Set a 1 sec time out to allow the soft keyboard show up first */
					setTimeout(function(){ 
						
						var top = 220;//170;		/* maximium ceiling of pageY */
						var y = e.target.getBoundingClientRect().top;	/* tap event firing position */
													
						/* Determine whether auto scroll is required in this event */
						if(y > top){
							/* Calculation moving distance */
							var moveD = top - y;
							/* Actual moving position */
							var actualMove = selfScroll.y + moveD;
							/* Remeber the position before auto scroll */
							selfScroll.autoScrollLastPos = selfScroll.y;
							/* Auto scroll up */
							selfScroll.scrollTo(0, actualMove);
						}						
					}, 800);					
				} 
				},
			});
	},
	
	/* Continue to Terms of Use page */
	continue: function(e) { 
	
		e.preventDefault();

		/* Validate input */
		if(!this.validate())
			return;
		
		/* Validate password */
		if(!this.validatePassword())
        	return;
       
       
		/* Go to Terms of Use page */
		var id = "#enrolment-term-page";
		$.mobile.changePage(id, {transition: 'slide'});
	},
	
	/* Validate input */
	validate: function() {
		valid = true;	

		/* Check name */
		var regexp = /^[a-zA-Z0-9- ]+$/;
		var enrolmentName = $("#enrolment-name").val(); 
		if(enrolmentName.length <= 0) {
			$("label[for='enrolment-name']").addClass("rexall-warning-label");
			valid &= false;
		}else{
			$("label[for='enrolment-name']").removeClass("rexall-warning-label");
		}
		
		/* Check email */
		if($("#enrolment-email").val().length <= 0 ){
			$("label[for='enrolment-email']").addClass("rexall-warning-label");
			valid &= false;
		}else{
		 if (!this.validateEmail($("#enrolment-email").val()))
			{$("label[for='enrolment-email']").addClass("rexall-warning-label");
			valid &= false;
		      }else{			
		     $("label[for='enrolment-email']").removeClass("rexall-warning-label");
   		     }
		}

		/* Check Province */
		if($("#enrolment-province").val()==null|| $("#enrolment-province").val() == "ChooseFromList"){
			$("label[for='enrolment-province']").addClass("rexall-warning-label");
			valid &= false;
		}else{
			$("label[for='enrolment-province']").removeClass("rexall-warning-label");
		}
		
		/* Check password */
		if($("#enrolment-password").val().length <= 0 ){
			$("label[for='enrolment-password']").addClass("rexall-warning-label");
			valid &= false;
		}else{
			$("label[for='enrolment-password']").removeClass("rexall-warning-label");
		}
		
		/* Check confirm password */
		if($("#enrolment-confirm-password").val().length <= 0 ){
			$("label[for='enrolment-confirm-password']").addClass("rexall-warning-label");
			valid &= false;
		}else{
			$("label[for='enrolment-confirm-password']").removeClass("rexall-warning-label");
		}
		
		/* Check Security Question */
		if($("#enrolment-security-question").val()==null || $("#enrolment-security-question").val() == "ChooseFromList"){
			$("label[for='enrolment-security-question']").addClass("rexall-warning-label");
			valid &= false;
		}else{
			$("label[for='enrolment-security-question']").removeClass("rexall-warning-label");
		}
		
		/* Check answer */
		if($("#enrolment-security-answer").val().length <= 0 ){
			$("label[for='enrolment-security-answer']").addClass("rexall-warning-label");
			valid &= false;
		}else{
			$("label[for='enrolment-security-answer']").removeClass("rexall-warning-label");
		}


		/* Error */
		if(!valid){
			jAlert("Correct the information highlighted in red.","Please Try Again");
		}
		else
		{
			var regexp = /^[a-zA-Z0-9- ]+$/;
			var enrolmentName = $("#enrolment-name").val(); 
			if(enrolmentName.search(regexp) == -1) {
			jAlert("Display name can only contain letters, numbers, and dashes.","Please Try Again");
				$("label[for='enrolment-name']").addClass("rexall-warning-label");
				valid &= false;
			}		
		}
		
		return valid;
		
	},
	
	/* Validate password */
	validatePassword: function() {
		
		var password = $("#enrolment-password").val(),
			confirm = $("#enrolment-confirm-password").val();
		    answer = $("#enrolment-security-answer").val();
		
		
		/* Validate password */
        if(password !== confirm){
        	jAlert('The passwords provided do not match.', 'Please Try Again');
              $("label[for='enrolment-confirm-password']").addClass("rexall-warning-label");
            $("label[for='enrolment-password']").addClass("rexall-warning-label");
        	return false;
		} 
        if(!password.match(/[1-9]/i) || !password.match(/[1-9]/i).length > 0){
        	jAlert('The password must contain at least 1 number', 'Please Try Again');
              $("label[for='enrolment-confirm-password']").addClass("rexall-warning-label");
            $("label[for='enrolment-password']").addClass("rexall-warning-label");
        	return false;
		} 
        if(!password.match(/[a-zA-Z]/g) || !password.match(/[a-zA-Z]/g).length > 0){
        	jAlert('The password must contain at least 1 letter', 'Please Try Again');
              $("label[for='enrolment-confirm-password']").addClass("rexall-warning-label");
            $("label[for='enrolment-password']").addClass("rexall-warning-label");
        	return false;
		} 
        if(password.length < 7){
        	jAlert('The password must contain at least 7 characters', 'Please Try Again');
              $("label[for='enrolment-confirm-password']").addClass("rexall-warning-label");
            $("label[for='enrolment-password']").addClass("rexall-warning-label");
        	return false;
		} 

        
        $("label[for='enrolment-confirm-password']").removeClass("rexall-warning-label");
        $("label[for='enrolment-password']").removeClass("rexall-warning-label");

        if(answer.length < 5){
        	jAlert('The answer to the security question must be at least 5 characters.', 'Please Try Again');
            $("label[for='enrolment-security-answer']").addClass("rexall-warning-label");
        	return false;
		} 
        else
        {
            $("label[for='enrolment-security-answer']").removeClass("rexall-warning-label");
        }
        
        return true;
	},
	
	/* reset input fields */
	resetRender: function() {
        if (this.backFromRejectTermandCondition)
        {
            this.backFromRejectTermandCondition =false;
            return;
        }
		/* remove warning */
		this.$el.find(".rexall-warning-label").removeClass("rexall-warning-label");
		/* clean input fields */
		this.$el.find("input").val("");
		this.$el.find("input[name='agree-enrollment']").attr("checked",false);
		setHTML5DateFormat("enrolment-request-birthdate");	

		this.$el.find("select").val("ChooseFromList");
		$("#enrollment-form-to-select").hide();
	},
	
	validateEmail: function(email) { 
  // http://stackoverflow.com/a/46181/11236
  
    var re = /^(([^<>()[\]\\.,;:\s@\"]+(\.[^<>()[\]\\.,;:\s@\"]+)*)|(\".+\"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
    return re.test(email);
	},	
});