var EnrolmentWaitView = Backbone.View.extend({
	
	el: $("#enrolment-wait-page"),
	
	events: {
		"tap #enrolment-wait-continue"	: "go",
		"tap .rexall-page-header-info"		: "showInfo",
		"tap .rexall-page-info-popup-close"	: "closeInfo",
	},
	
	initialize: function() {
		 /* Set up popup information scroller */
		this.infoScroll = new iScroll("enrolment-wait-page-info-scroll",{
			hScroll:false, 
			vScroll:true, 
			vScrollbar: true, 
			hScrollbar: false, 
			fadeScrollbar: true, 
			hideScrollbar:true,
			});
		this.infoScroll.refresh();
	},
	
	go: function() {

		var id = "#enrolment-confirm-page";
		$.mobile.changePage(id, {transition: 'slide'});	
	},
	
	/* Show refill page information pop up */
	showInfo: function(e) {

		e.preventDefault();
//		if(janrainLogin.get("hasLogin") && localStorage.getItem("JanRainLogin")){
//			/* Logged in */
//			$("#enrolment-wait-popup-users-signed-in").show();
//			$("#enrolment-wait-popup-users-not-signed-in").hide();
//
//		}else{
//			/* not Logged in */
//			$("#enrolment-wait-popup-users-signed-in").hide();
//			$("#enrolment-wait-popup-users-not-signed-in").show();
//		}
		/* Open information box */
		$("#enrolment-wait-page-info").popup( "option", "history", false );
		$("#enrolment-wait-page-info").popup({ transition: "pop" });
		$("#enrolment-wait-page-info").popup("open");

	},

	/* Close information */
	closeInfo: function(e) {

		e.preventDefault();

		$("#enrolment-wait-page-info").popup("close");

	},
	
	resetRender: function(){
		if(janrainLogin.get("hasLogin") && localStorage.getItem("JanRainLogin")){
			/* Logged in */
			$("#enrolment-wait-popup-users-signed-in").show();
			$("#enrolment-wait-popup-users-not-signed-in").hide();
		}else{
			/* not Logged in */
			$("#enrolment-wait-popup-users-signed-in").hide();
			$("#enrolment-wait-popup-users-not-signed-in").show();
		}
	},
});