var ShoppingItemView = Backbone.View.extend({
 
    tagName:  "li",
        
    template: Handlebars.compile($("#shopping-item-template").html()),
 
    events: {
      //"tap label"   			: "toggleDone",
      "tap .shopping-destory" 	: "destroy",
      //"dblclick .view"  : "edit",
      //"keypress .edit"  : "updateOnEnter",
      //"blur .edit"      : "close"
    },
    
    initialize: function() {
      this.listenTo(this.model, 'change', this.render);
      this.listenTo(this.model, 'destroy', this.remove);
      
      /* Set toggle function !!!!Should find a better way to do this .... */
      var self = this;
      this.$el.on("tap", function(e) {
    	  e.preventDefault();
    	  self.toggleDone();
      });
    },
 
    render: function() {
    	this.$el.html(this.template(this.model.toJSON()));
    	this.$el.toggleClass('shopping-done', this.model.get('done'));
    	/* Set check box */
    	this.$el.children(".shopping-toggle").attr("checked", this.model.get('done'));
    	
    	return this;
    },
 
    toggleDone: function() {
      this.model.toggle();
    },
//    
//    edit: function() {
//      this.$el.addClass("editing");
//      this.input.focus();
//    },
// 
//    close: function() {
//      var value = this.input.val();
//      if (!value) {
//        this.clear();
//      } else {
//        this.model.save({title: value});
//        this.$el.removeClass("editing");
//      }
//    },
// 
//    updateOnEnter: function(e) {
//      if (e.keyCode == 13) this.close();
//    },
// 
    destroy: function(e) {
        e.preventDefault();
        e.stopPropagation();
        var modelOutside = this.model;
        jConfirm('Delete this item?', 'Please Confirm', function(r) {
            if (r) {
              
                modelOutside.destroy();
            }
            else {
                return false;
            }
        }) 
  
    }
    
});